﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
public class MultipleColorBufferTest : MonoBehaviour
{
    public Material CustomBlitMaterial;
    RenderTexture r1;
    RenderTexture r2;
    RenderBuffer[] colorRenderBuffers;
    void Start()
    {
        RenderTextureDescriptor d = new RenderTextureDescriptor(Screen.width, Screen.height, RenderTextureFormat.ARGB32);
        r1 = new RenderTexture(d);
        r2 = new RenderTexture(d);
        r1.Create();
        r2.Create();
        r1.name = "r1 color buffer";
        r2.name = "r2 color buffer";
        colorRenderBuffers = new RenderBuffer[2]
        {
                     r1.colorBuffer,
                     r2.colorBuffer
        };
    }
    void OnRenderImage(RenderTexture src, RenderTexture dst)
    {
        Graphics.SetRenderTarget(colorRenderBuffers, r1.depthBuffer);
        GL.Clear(true, true, Color.blue);
        CustomBlitMaterial.SetPass(0);
        GL.PushMatrix();
        GL.Viewport(new Rect(0, 0, Screen.width, Screen.height));
        // Manually render a full screen quad that will
        // be either red or green as determined by the custom blit shader.
        GL.Begin(GL.QUADS);
        float z = 1f;
        GL.Vertex(new Vector3(-1, -1, z));
        GL.Vertex(new Vector3(-1, 1, z));
        GL.Vertex(new Vector3(1, 1, z));
        GL.Vertex(new Vector3(1, -1, z));
        GL.End();
        GL.PopMatrix();
        Graphics.Blit(r1, dst); // Render the Red color buffer
        //Graphics.Blit (r2, dst);  // Render the Green color buffer
    }
}